﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TreeSharp;
using Styx;

namespace FelMaster.Classes.Hunter
{
    class BeastMastery : TalentBase
    {
        public override string Name
        {
            get { return "FallDowns Solo BeastMastery"; }
        }

        public override string KeySpell
        {
            get { return "Intimidation"; }
        }

		// Always camouflage
		// Sap like behaviour for two targets.
		
        public override Composite SingleRotation
        {
            get {
                return new PrioritySelector(
                    SC.CastBuff("Aspect of the Hawk", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Aspect of the Hawk"),
					SC.CastSpell("Deterrence", a => Me.HealthPercent < 40 && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Deterrence"),
					SC.CastSpell("Feign Death", a => Me.HealthPercent < 25 && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher"), "Low on health, Feign Death"),
					SC.CastSpell("Feign Death", a => Me.CurrentTarget.CurrentTargetGuid == Me.Guid && Me.HealthPercent < 50 && Me.CurrentTarget.Distance < 10 && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher"), "Aggro'd, Feign Death"),
					SC.RunMacroText("/cast [target=pet,exists] Misdirection", a => SC.CanCast("Misdirection") && !SC.PlayerHasBuff("Misdirection") && Me.CurrentTarget.CurrentTargetGuid == Me.Guid && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Misdirection on pet"),
					//SC.CastPetAttack(a => !Styx.Logic.Combat.WoWPetSpell.Stance("Passive") && Me.GotTarget && Me.CurrentTarget.CurrentTargetGuid == Me.Guid && Me.Pet.CurrentTargetGuid != Me.CurrentTargetGuid && !Me.Auras.ContainsKey("Trap Launcher") && Me.GotAlivePet, "Pet Attack"),
					SC.CastDebuff("Concussive Shot", a => Me.GotTarget && Me.CurrentTarget.CurrentTargetGuid == Me.Guid && Me.CurrentTarget.Distance < 35 && Me.CurrentTarget.Distance > 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Concussive Shot"),
					SC.CastSpell("Ice Trap", a => SC.CountEnnemiesInRange(Me.Location, 15) > 2 && SC.CanCast("Ice Trap") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Ice Trap"),
					SC.CastSpell("Scatter Shot", a => Me.GotTarget && Me.CurrentTarget.CurrentTargetGuid == Me.Guid && Me.CurrentTarget.Distance < 20 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too close, Scatter Shot"),
			        SC.CastSpell("Disengage", a => Me.CurrentTarget.Distance < 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too close, Disengaging"),
					SC.CastSpell("Raptor Strike", a => Me.CurrentTarget.Distance < 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too Close, Melee"),
					SC.CastDebuff("Wing Clip", a => !Me.IsCasting && !SC.TargetHasDebuff("Concussive Shot") && !SC.TargetHasDebuff("Wing Clip") && Me.CurrentTarget.Distance < 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too Close, Wing Clip"),
					SC.CastSpell("Kill Shot", a => Me.CurrentTarget.HealthPercent < 20 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Kill Shot"),
					SC.CastSpell("Lifeblood", a => !SC.PlayerHasBuff("Bestial Wrath") && Me.CurrentTarget.Level >= Me.Level && Me.CurrentTarget.HealthPercent > 20 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Lifeblood"),
					SC.CastBuff("Rapid Fire", a => !SC.PlayerHasBuff("Bestial Wrath") &&  Me.CurrentTarget.Level > Me.Level && Me.CurrentTarget.HealthPercent > 40 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Rapid Fire"),
					SC.UseEquippedItem(13, a => Me.CurrentTarget.Level >= Me.Level && Me.CurrentTarget.HealthPercent > 20 && StyxWoW.Me.Inventory.Equipped.Trinket1 != null && StyxWoW.Me.Inventory.Equipped.Trinket1.Cooldown <= 0 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Using trinket 1"),
					SC.UseEquippedItem(14, a => Me.CurrentTarget.Level >= Me.Level && Me.CurrentTarget.HealthPercent > 20 && StyxWoW.Me.Inventory.Equipped.Trinket2 != null && StyxWoW.Me.Inventory.Equipped.Trinket2.Cooldown <= 0 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Using trinket 2"),
					SC.CastDebuff("Hunter's Mark", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Hunter's Mark"),
					SC.CastSpell("Intimidation", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Intimidation"),
					SC.CastSpell("Fervor", a => Me.FocusPercent < 36 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Fervor"),
					SC.CastUniqueSpell("Trap Launcher", a => SC.CountEnnemiesInRange(Me.CurrentTarget.Location, 10) > 3 && SC.CanCast("Explosive Trap") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Trap Launcher"),
					SC.CastSpellAtTargetLocation("Explosive Trap", a => SC.CountEnnemiesInRange(Me.CurrentTarget.Location, 10) > 3 && SC.CanCast("Explosive Trap") && Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Explosive Trap"),
					SC.CastSpell("Multi-Shot", a => SC.CountEnnemiesInRange(Me.CurrentTarget.Location, 10) > 2 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Multi-Shot"),
					SC.CastDebuff("Serpent Sting", a => Me.CurrentTarget.HealthPercent > 30 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Serpent Sting"),
					SC.CastSpell("Bestial Wrath", a => !SC.PlayerHasBuff("Rapid Fire") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Bestial Wrath"),
					SC.CastSpell("Kill Command", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Kill Command"),
					SC.CastSpell("Focus Fire", a => Me.Pet.HasAura("Frenzy Effect") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Focus Fire"),
					SC.CastSpell("Arcane Shot", a => Me.FocusPercent > 60 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Arcane Shot"),
					SC.CastSpell("Cobra Shot", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Cobra Shot for focus")
                );
            }
        }

        public override Composite Buffs
        {
            get
            {
                return new PrioritySelector(
					SC.CastSpell("Mend Pet", a => !SC.PetHasBuff("Mend Pet") && !Me.Mounted && !Me.IsCasting && !Me.Dead && !SC.PlayerHasBuff("Feign Death") && Me.Pet.HealthPercent < 50 && Me.GotAlivePet, "Mending Pet"),
					SC.CastSpell("Mend Pet", a => !SC.PetHasBuff("Mend Pet") && !Me.Mounted && !Me.IsCasting && !Me.Combat && !Me.GotTarget && !Me.Dead && !SC.PlayerHasBuff("Feign Death") && Me.Pet.HealthPercent < 90 && Me.GotAlivePet, "Mending Pet"),
					SC.CastSpell("Call Pet 2", a => !Me.Mounted && !Me.IsMoving && !Me.Combat && !Me.GotTarget && !Me.IsCasting && !Me.Dead && !SC.PlayerHasBuff("Feign Death") && SC.CountEnnemiesInRange(Me.Location, 10) < 1 && (Pet == null), "Call Pet"),
					SC.CastSpell("Revive Pet", a => !Me.Mounted && !Me.IsMoving && !Me.Combat && !Me.GotTarget && !Me.IsCasting && !Me.Dead && !SC.PlayerHasBuff("Feign Death") && SC.CountEnnemiesInRange(Me.Location, 10) < 1 && (Pet == null || Pet.Dead), "Calling Pet")
                );
            }
        }

        public override Composite PVPRotation
        {
            get { throw new NotImplementedException(); }
        }

        public override Composite PVERotation
        {
            get
            {
                return SingleRotation;
            }
        }
    }
}
