﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TreeSharp;
using Styx;

namespace FelMaster.Classes.Hunter
{
    class Marksmanship : TalentBase
    {
        public override string Name
        {
            get { return "FallDowns Raid Marksmanship"; }
        }

        public override string KeySpell
        {
            get { return "Aimed Shot"; }
        }

        public override Composite SingleRotation
        {
            get {
                return new PrioritySelector(
					SC.CastBuff("Aspect of the Hawk", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Aspect of the Hawk"),
					SC.CastSpell("Deterrence", a => Me.HealthPercent < 25 && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Deterrence"),
					SC.CastSpell("Feign Death", a => Me.HealthPercent < 15 && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher"), "Low on health, Feign Death"),
					SC.CastSpell("Feign Death", a => Me.CurrentTarget.CurrentTargetGuid == Me.Guid && Me.HealthPercent < 50 && Me.CurrentTarget.Distance < 10 && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher"), "Aggro'd, Feign Death"),
					//SC.RunMacroText("/cast [target=pet,exists] Misdirection", a => SC.CanCast("Misdirection") && !SC.PlayerHasBuff("Misdirection") && Me.CurrentTarget.CurrentTargetGuid == Me.Guid && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Misdirection on pet"),
					SC.CastDebuff("Concussive Shot", a => Me.GotTarget && Me.CurrentTarget.CurrentTargetGuid == Me.Guid && Me.CurrentTarget.Distance < 20 && Me.CurrentTarget.Distance > 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Concussive Shot"),
					SC.CastSpell("Scatter Shot", a => Me.CurrentTarget.Distance < 8 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too close, Scatter Shot"),
			        //SC.CastSpell("Disengage", a => Me.CurrentTarget.Distance < 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too close, Disengaging"),
					SC.CastSpell("Raptor Strike", a => Me.CurrentTarget.Distance < 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too Close, Melee"),
					SC.CastDebuff("Wing Clip", a => !Me.IsCasting && !SC.TargetHasDebuff("Concussive Shot") && Me.CurrentTarget.Distance < 5 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Too Close, Wing Clip"),
					SC.CastSpell("Lifeblood", a => Me.CurrentTarget.Level >= 76 && Me.CurrentTarget.HealthPercent > 20 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Lifeblood"),
					SC.CastBuff("Rapid Fire", a => Me.CurrentTarget.Level >= 77 && Me.CurrentTarget.HealthPercent > 30 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Rapid Fire"),
					SC.CastSpell("Readiness", a => SC.PlayerHasBuff("Rapid Fire") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Readiness"),
					SC.UseEquippedItem(13, a => Me.CurrentTarget.Level > Me.Level && Me.CurrentTarget.HealthPercent > 30 && StyxWoW.Me.Inventory.Equipped.Trinket1 != null && StyxWoW.Me.Inventory.Equipped.Trinket1.Cooldown <= 0 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Using trinket 1"),
					SC.UseEquippedItem(14, a => Me.CurrentTarget.Level > Me.Level && Me.CurrentTarget.HealthPercent > 30 && StyxWoW.Me.Inventory.Equipped.Trinket2 != null && StyxWoW.Me.Inventory.Equipped.Trinket2.Cooldown <= 0 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Using trinket 2"),				
					SC.CastSpell("Aimed Shot", a => SC.PlayerHasBuff("Fire!") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Instant Aimed"),
					SC.CastSpell("Kill Shot", a => Me.CurrentTarget.HealthPercent < 20 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Kill Shot"),
					SC.CastSpell("Silencing Shot", a => Me.CurrentTarget.IsCasting && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Silencing Shot"),
					SC.CastDebuff("Hunter's Mark", a => !SC.TargetHasDebuff("Marked For Death") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Hunter's Mark"),
					SC.CastSpell("Trap Launcher", a => SC.CountEnnemiesInRange(Me.CurrentTarget.Location, 10) > 4 && SC.CanCast("Explosive Trap") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Trap Launcher"),
					SC.CastSpellAtTargetLocation("Explosive Trap", a => SC.CountEnnemiesInRange(Me.CurrentTarget.Location, 10) > 4 && SC.CanCast("Explosive Trap") && Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Explosive Trap"),
					SC.CastSpell("Multi-Shot", a => SC.CountEnnemiesInRange(Me.CurrentTarget.Location, 10) > 2 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Multi-Shot"),
					SC.CastDebuff("Serpent Sting", a => Me.CurrentTarget.CurrentHealth > 150000 || Me.CurrentTarget.MaxHealth == 1 && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Serpent Sting"),
					SC.CastSpell("Chimera Shot", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Chimera Shot"),
					SC.CastSpell("Steady Shot", a => !SC.PlayerHasBuff("Improved Steady Shot") && Me.FocusPercent < 75 && !Me.IsMoving && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Steady Shot for Improved Steady Shot"),
					SC.CastSpell("Aimed Shot", a => (Me.FocusPercent > 60 && Me.CurrentTarget.HealthPercent > 90) || (SC.PlayerHasBuff("Rapid Fire")) && !Me.IsMoving && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Aimed Shot"),
					SC.CastSpell("Arcane Shot", a => Me.CurrentTarget.HealthPercent < 90 && Me.FocusPercent > 50 && !SC.PlayerHasBuff("Rapid Fire") && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Arcane Shot"),						
					SC.CastSpell("Steady Shot", a => !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death"), "Steady Shot for Focus")
                );
            }
        }

        public override Composite Buffs
        {
            get
            {
                return new PrioritySelector(
					SC.CastSpell("Mend Pet", a => !SC.PetHasBuff("Mend Pet") && !Me.Mounted && !Me.IsCasting && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death") && Me.Pet.HealthPercent < 30 && Me.GotAlivePet, "Mending Pet")
					//SC.CastPet("Revive Pet", "Call Pet 1", a => !Me.Mounted && !Me.IsMoving && !Me.Combat && !Me.GotTarget && !Me.IsCasting && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death") && (Pet == null || Pet.Dead) && SC.CountEnnemiesInRange(Me.Location, 10) < 1, "Call Pet, revive if dead"),
					//SC.CastSpell("Call Pet 1", a => !Me.Mounted && !Me.IsMoving && !Me.Combat && !Me.GotTarget && !Me.IsCasting && !Me.Dead && !Me.Auras.ContainsKey("Trap Launcher") && !SC.PlayerHasBuff("Feign Death") && (Pet == null) && SC.CountEnnemiesInRange(Me.Location, 10) < 1, "Calling Pet")
                );
            }
        }

        public override Composite PVPRotation
        {
            get { throw new NotImplementedException(); }
        }

        public override Composite PVERotation
        {
            get
            {
                return SingleRotation;
            }
        }
    }
}
