﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TreeSharp;

namespace FelMaster.Classes.Warlock
{
    class Destruction :TalentBase
    {
        public override string Name
        {
            get { return "Cowdude's Destruction priority list"; }
        }

        public override string KeySpell
        {
            get { return "Conflagrate"; }
        }

        public override Composite SingleRotation
        {
            get {
                return new PrioritySelector(
                    SC.CastSpell("Life Tap", a => Me.ManaPercent < 20, "Life tap - mana < 20%"),

                    SC.CastDebuff("Curse of the Elements", a => Me.CurrentTarget.HealthPercent > 70, "CoE"),
                    SC.CastUniqueSpell("Summon Imp", a => (Me.Pet == null || Me.Pet.Dead) && (SC.PlayerHasBuff("Demonic Rebirth") || SC.PlayerHasBuff("Soulburn")), "Summon new Imp"),
                    SC.CastSpell("Demon Soul", a => !Me.IsMoving, "Demon Soul while not moving"),
                    SC.CastSpell("Soulburn", a => true, "Soulburn"),
                    SC.CastSpell("Soul Fire", a => SC.PlayerHasBuff("Soulburn"), "SF on soulburn"),
                    SC.CastDebuff("Immolate", a => true, "Immolate"),
                    SC.CastSpell("Conflagrate", a => SC.TargetHasDebuff("Immolate"), "Conflagrate"),
                    SC.CastDebuff("Bane of Doom", a => Me.CurrentTarget.CurrentHealth > 100000 || Me.CurrentTarget.MaxHealth == 1, "Bane of Doom"),
                    SC.CastDebuff("Corruption", a => true, "Corruption"),
                    SC.CastSpell("Soul Fire", a => SC.PlayerHasBuff("Empowered Imp"), "SF on imp buff"),
                    SC.CastSpell("Chaos Bolt", a => true, "Chaos Bolt"),
                    SC.CastSpell("Summon Doomguard", a => true, "Doomguard"),
                    SC.CastOffensiveBuff("Soul Fire", "Improved Soul Fire", SC.CastTime("Incinerate") + 0.5, "SF to refresh buff... (Incinerate+GCD=" + (SC.CastTime("Incinerate") + 0.5) + ")"),
                    SC.CastSpell("Shadowburn", a => Me.CurrentTarget.HealthPercent < 20, "Shadowburn"),
                    SC.CastSpell("Incinerate", a => SC.TargetHasDebuff("Immolate"), "Incinerate"),
                    SC.CastSpell("Life Tap", a => Me.IsMoving && Me.HealthPercent > Me.ManaPercent && Me.ManaPercent < 80, "Life tap while moving"),
                    SC.CastSpell("Fel Flame", a => Me.IsMoving, "Fel flame while moving")
                );
            }
        }

        public override Composite Buffs
        {
            get
            {
                return new PrioritySelector(
                    //buffs
                    SC.CastBuff("Fel Armor", a => true, "Fel Armor"),
                    SC.CastUniqueSpell("Summon Imp", a => !Me.Combat && !Me.Mounted && Pet == null || Pet.Dead, "Summon new Imp"),
                    SC.CastBuff("Soul Link", a => Pet != null && Pet.IsAlive, "Soul Link")
                );
            }
        }

        public override Composite PVPRotation
        {
            get { throw new NotImplementedException(); }
        }

        public override Composite PVERotation
        {
            get
            {
                return SingleRotation;
            }
        }
    }
}
